#include "X3D_RenderingCreator.h"
#include "X3D_Color.h"
#include "X3D_ColorRGBA.h"
#include "X3D_Coordinate.h"
#include "X3D_IndexedLineSet.h"
#include "X3D_Normal.h"
#include "X3D_PointSet.h"
#include "X3D_TriangleFanSet.h"
#include "X3D_TriangleSet.h"
#include "X3D_TriangleStripSet.h"

namespace X3DTK {
namespace X3D {

RenderingCreator::RenderingCreator()
{
  defineComponentName("Rendering", "X3D");

  define(Recorder<Color>::getCreationFunction());
  define(Recorder<ColorRGBA>::getCreationFunction());
  define(Recorder<Coordinate>::getCreationFunction());
  define(Recorder<IndexedLineSet>::getCreationFunction());
  define(Recorder<Normal>::getCreationFunction());
  define(Recorder<PointSet>::getCreationFunction());
  define(Recorder<TriangleFanSet>::getCreationFunction());
  define(Recorder<TriangleSet>::getCreationFunction());
  define(Recorder<TriangleStripSet>::getCreationFunction());
}

RenderingCreator::~RenderingCreator()
{
}

}
}
