#include "libXMLFileElement.h"

#include <iostream>

using namespace std;

namespace X3DTK {

class libXMLFileElementImplementation
{
public:
  libXMLFileElementImplementation(){};
  
  SFString name;
  const xmlChar **attributes;
};

libXMLFileElement::libXMLFileElement(const SFString &name, const void *const attributes)
: impl(new libXMLFileElementImplementation())
{
  impl->name = name;
  impl->attributes = (const xmlChar **)attributes;
}

libXMLFileElement::~libXMLFileElement()
{
}

SFString libXMLFileElement::getName() const
{
  return impl->name;
}

SFString libXMLFileElement::getAttribute(int i) const
{
  return impl->attributes[2*i + 1];
}

int libXMLFileElement::getIndexAttribute(const SFString &attribute) const
{
  for (int i = 0; impl->attributes && impl->attributes[i] != NULL; i += 2) 
  {
    if (attribute == SFString(impl->attributes[i]))
      return i >> 1;
  }    

  return -1;
}

}
