#include "X3D_Cone.h"

namespace X3DTK {
namespace X3D {

Cone::Cone()
: X3DGeometryNode()
{
  define(Recorder<Cone>::getTypeName("Cone", "Geometry3D"));
  
  define(Recorder<Cone, SFFloat>::getAttribute("bottomRadius", &Cone::_bottomRadius, 1.0f));
  define(Recorder<Cone, SFFloat>::getAttribute("height", &Cone::_height, 2.0f));
  define(Recorder<Cone, SFBool>::getAttribute("side", &Cone::_side, true));
  define(Recorder<Cone, SFBool>::getAttribute("bottom", &Cone::_bottom, true));
}

Cone::~Cone()
{
}

void Cone::setBottomRadius(const SFFloat &bottomRadius)
{
  _bottomRadius = bottomRadius;
}

void Cone::setHeight(const SFFloat &height)
{
  _height = height;
}

void Cone::setSide(const SFBool &side)
{
  _side = side;
}

void Cone::setBottom(const SFBool &bottom)
{
  _bottom = bottom;
}

}
}
