#include "X3D_NurbsCurve.h"

#include <iostream>

using namespace std;

namespace X3DTK {
namespace X3D {

NurbsCurve::NurbsCurve()
: X3DParametricGeometryNode()
{
  define(Recorder<NurbsCurve>::getTypeName("NurbsCurve", "NURBS"));
  
  define(Recorder<NurbsCurve, MFVec3f>::getAttribute("controlPoint", &NurbsCurve::_controlPoint, MFVec3f()));
  define(Recorder<NurbsCurve, SFInt32>::getAttribute("tesselation", &NurbsCurve::_tesselation, 0));
  define(Recorder<NurbsCurve, MFDouble>::getAttribute("weight", &NurbsCurve::_weight, MFDouble()));
  define(Recorder<NurbsCurve, MFDouble>::getAttribute("knot", &NurbsCurve::_knot, MFDouble()));
  define(Recorder<NurbsCurve, SFInt32>::getAttribute("order", &NurbsCurve::_order, 3));
}

NurbsCurve::~NurbsCurve()
{
}

void NurbsCurve::setControlPoint(const MFVec3f &controlPoint)
{
  _controlPoint = controlPoint;
}

void NurbsCurve::setTesselation(const SFInt32 &tesselation)
{
  _tesselation = tesselation;
}

void NurbsCurve::setWeight(const MFDouble &weight)
{
  _weight = weight;
}

void NurbsCurve::setKnot(const MFDouble &knot)
{
  _knot = knot;
}

void NurbsCurve::setOrder(const SFInt32 &order)
{
  _order = order;
}

}
}
