#include "X3D_NurbsTextureSurface.h"

#include <iostream>

using namespace std;

namespace X3DTK {
namespace X3D {

NurbsTextureSurface::NurbsTextureSurface()
: X3DTextureCoordinateNode()
{
  define(Recorder<NurbsTextureSurface>::getTypeName("NurbsTextureSurface", "NURBS"));
  
  define(Recorder<NurbsTextureSurface, MFVec2f>::getAttribute("controlPoint", &NurbsTextureSurface::_controlPoint, MFVec2f()));
  define(Recorder<NurbsTextureSurface, MFFloat>::getAttribute("weight", &NurbsTextureSurface::_weight, MFFloat()));
  define(Recorder<NurbsTextureSurface, SFInt32>::getAttribute("uDimension", &NurbsTextureSurface::_uDimension, 0));
  define(Recorder<NurbsTextureSurface, SFInt32>::getAttribute("vDimension", &NurbsTextureSurface::_vDimension, 0));
  define(Recorder<NurbsTextureSurface, MFDouble>::getAttribute("uKnot", &NurbsTextureSurface::_uKnot, MFDouble()));
  define(Recorder<NurbsTextureSurface, MFDouble>::getAttribute("vKnot", &NurbsTextureSurface::_vKnot, MFDouble()));
  define(Recorder<NurbsTextureSurface, SFInt32>::getAttribute("uOrder", &NurbsTextureSurface::_uOrder, 3));
  define(Recorder<NurbsTextureSurface, SFInt32>::getAttribute("vOrder", &NurbsTextureSurface::_vOrder, 3));
}

NurbsTextureSurface::~NurbsTextureSurface()
{
}

void NurbsTextureSurface::setControlPoint(const MFVec2f &controlPoint)
{
  _controlPoint = controlPoint;
}

void NurbsTextureSurface::setWeight(const MFFloat &weight)
{
  _weight = weight;
}

void NurbsTextureSurface::setUDimension(const SFInt32 &uDimension)
{
  _uDimension = uDimension;
}

void NurbsTextureSurface::setVDimension(const SFInt32 &vDimension)
{
  _vDimension = vDimension;
}

void NurbsTextureSurface::setUKnot(const MFDouble &uKnot)
{
  _uKnot = uKnot;
}

void NurbsTextureSurface::setVKnot(const MFDouble &vKnot)
{
  _vKnot = vKnot;
}

void NurbsTextureSurface::setUOrder(const SFInt32 &uOrder)
{
  _uOrder = uOrder;
}

void NurbsTextureSurface::setVOrder(const SFInt32 &vOrder)
{
  _vOrder = vOrder;
}

}
}
