#include "X3D_X3DComposedGeometryNode.h"
#include "X3D_X3DColorNode.h"
#include "X3D_X3DCoordinateNode.h"
#include "X3D_X3DNormalNode.h"
#include "X3D_X3DTextureCoordinateNode.h"

#include <iostream>

using namespace std;

namespace X3DTK {
namespace X3D {

X3DComposedGeometryNode::X3DComposedGeometryNode()
: X3DGeometryNode()
{
  define(Recorder<X3DComposedGeometryNode>::getTypeName("X3DComposedGeometryNode"));

  define(Recorder<X3DComposedGeometryNode, SFBool>::getAttribute("ccw", &X3DComposedGeometryNode::_ccw, true));
  define(Recorder<X3DComposedGeometryNode, SFBool>::getAttribute("colorPerVertex", &X3DComposedGeometryNode::_colorPerVertex, true));
  define(Recorder<X3DComposedGeometryNode, SFBool>::getAttribute("normalPerVertex", &X3DComposedGeometryNode::_normalPerVertex, true));
  define(Recorder<X3DComposedGeometryNode, SFBool>::getAttribute("solid", &X3DComposedGeometryNode::_solid, true));
  
  define(Recorder<X3DComposedGeometryNode, X3DColorNode>::getSFNode("color", &X3DComposedGeometryNode::_color));
  define(Recorder<X3DComposedGeometryNode, X3DCoordinateNode>::getSFNode("coord", &X3DComposedGeometryNode::_coord));
  define(Recorder<X3DComposedGeometryNode, X3DNormalNode>::getSFNode("normal", &X3DComposedGeometryNode::_normal));
  define(Recorder<X3DComposedGeometryNode, X3DTextureCoordinateNode>::getSFNode("texCoord", &X3DComposedGeometryNode::_texCoord));
}

X3DComposedGeometryNode::~X3DComposedGeometryNode()
{
  removeChildren();
}

void X3DComposedGeometryNode::setCcw(const SFBool &ccw)
{
  _ccw = ccw;
}

void X3DComposedGeometryNode::setColorPerVertex(const SFBool &colorPerVertex)
{
  _colorPerVertex = colorPerVertex;
}

void X3DComposedGeometryNode::setNormalPerVertex(const SFBool &normalPerVertex)
{
  _normalPerVertex = normalPerVertex;
}

void X3DComposedGeometryNode::setSolid(const SFBool &solid)
{
  _solid = solid;
}

}
}
