#include "X3D_GLBuilder.h"
#include "DFSGraphTraversal.h"
#include "X3D_GLBuilderCoreVisitor.h"
#include "X3D_GLBuilderGeometry3DVisitor.h"
#include "X3D_GLBuilderGroupingVisitor.h"
#include "X3D_GLBuilderRenderingVisitor.h"
#include "X3D_GLBuilderShapeVisitor.h"
#include "X3D_GLBuilderTexturingVisitor.h"
#include "X3D_GLBuilderNavigationVisitor.h"

#include <iostream>

using namespace std;

namespace X3DTK {
namespace X3D {

GLBuilder::GLBuilder()
: X3DOnePassProcessor()
{
  setGraphTraversal(new DFSGraphTraversal());
  setComponentVisitor(new GLBuilderCoreVisitor());
  setComponentVisitor(new GLBuilderGeometry3DVisitor());
  setComponentVisitor(new GLBuilderGroupingVisitor());
  setComponentVisitor(new GLBuilderRenderingVisitor());
  setComponentVisitor(new GLBuilderShapeVisitor());
  setComponentVisitor(new GLBuilderTexturingVisitor());
  setComponentVisitor(new GLBuilderNavigationVisitor());
}

GLBuilder::~GLBuilder()
{
  Singleton<GLBuilderStateVariables>::removeInstance();
}

GL::X3DNode *GLBuilder::build(X3DNode *N)
{
  Singleton<GLBuilderStateVariables>::getInstance()->init();
  traverse(N);
  Singleton<GLBuilderStateVariables>::getInstance()->finish();
    
  return Singleton<GLBuilderStateVariables>::getInstance()->getRoot();
}

GL::Scene *GLBuilder::build(Scene *S)
{
  return static_cast<GL::Scene *>(build(static_cast<X3DNode *>(S)));
}

}
}
